import ea.*; //Importieren der gesamten Engine Alpha
/**
 * Die Spielsteuerungsklasse
 */
public class MeinSpiel
extends Game
implements TastenGedruecktReagierbar
{
    private static final int METEORITENZAHL = 100;
    private Figur rakete;
    private Bild mond;
    public Bild[] meteor;
    
    /**
     * Konstruktor, erstellt das Spielfenster und alle Hintergrundressourcen
     * in der Klasse <code>Game</code>
     */
    public MeinSpiel() {
        super(700, 600); //Aufruf des Konstruktors der Klasse Game; 
        super.tastenGedruecktReagierbarAnmelden(this);
        mond = new Bild(0,400,"mond.jpg");
        sichtbarMachen(mond);
        meteor = new Bild[METEORITENZAHL];
        for (int i=0; i<METEORITENZAHL; i++) {
            int x,y;
            x=zufallsZahl(700);
            y=-50-i*50;
            meteor[i] = new Bild (x,y,"meteor-klein.gif");
            animationsManager.geradenAnimation(meteor[i],new Punkt(x,900),5000+i*100,5000+i*100);
            sichtbarMachen(meteor[i]);        
        }
        rakete = new Figur(350,480,"rakete.eaf");
        sichtbarMachen(rakete);
        MeinTicker ticker = new MeinTicker(this);
        manager.anmelden(ticker,250);
    }
    
    /**
     * Diese Methode wird immer dann aufgerufen, wenn eine der Tasten der
     * Tastatur gedrueckt wurde.
     * @param   tastenCode  Der Code der gedrueckten Taste als Zahl. Dadurch 
     *  kann man die Tasten unterscheiden und entsprechend auf darauf reagieren.
     *  Zum Beispiel mit einer <code>switch</code>-Anweisung
     */
    public void tasteReagieren(int tastenCode) {
        if (tastenCode==1)
        {
            System.exit(0);
        }
    }

    public void tasteGedrueckt(int tastenCode) {
        if (tastenCode==26)
        {
            rakete.verschieben(0,-3);
        }
        if (tastenCode==27)
        {
            rakete.verschieben(3,0);
        }
        if (tastenCode==28)
        {
            rakete.verschieben(0,3);
        }
        if (tastenCode==29)
        {
            rakete.verschieben(-3,0);
        }
    }

    public void sichtbarMachen(Raum m) {
        wurzel.add(m);
    }
    
    public boolean kollisionstest() {
        boolean treffer=false;
        for (int i=0; i<METEORITENZAHL; i++)
        {
            if (rakete.schneidet(meteor[i])==true) treffer=true;
        }
        return treffer;
    }

//    public boolean level_geschafft_test() {
//        if 
    
    public void gameover()
    {
        wurzel.leeren();
        Text t1 = new Text("GAME OVER!",100,100,"Arial",24,0,"Gruen");
        Text t2 = new Text("Zum Beenden bitte 'B' drücken!",100,160,"Arial",18,0,"Gruen");
        sichtbarMachen(t1);
        sichtbarMachen(t2);
    }
}